【AcWing 158周赛】

5842. 拆树

主要思路:

  • 如何分割?
    深度遍历,当遍历的子数的sum为总sum的三分之一即是一个分割方法。
    1其中要注意节点范围为 − 100 , 100 -100,100 −100,100,所以当 总树 s u m = 0 总树sum=0 总树sum=0时,可能可以分成大于3部分。所以最后输出答案时判断条件应该用 a n s . s i z e ( ) > 2 ans.size() > 2 ans.size()>2
  • 这种方法会不会遗漏答案?
    不会,因为从根节点遍历,任意答案方案都能通过上面的方法得到。
输入样例1:
复制代码
6
2 4
0 5
4 2
2 1
1 1
4 2
输出样例1:
复制代码
1 4
c 复制代码
#include<iostream>
#include<vector>
using namespace std;

const int N = 1e6 + 10;
int d[N], n, h[N], e[N], ne[N], ind = 0;
double sum = 0;
vector<int> ans;

void add(int b, int a) {
    e[++ind] = a;
    ne[ind] = h[b];
    h[b] = ind;
}

void dfs(int r) {
    for (int i = h[r]; i; i = ne[i]) {
        int t = e[i];
        dfs(t);
        d[r] += d[t];
    }
    if (d[r] == sum / 3) {
         ans.push_back(r);
        d[r] = 0;
    }
}
int main() {
     cin >> n;
     int r = 0;
     int x;
     for (int i = 1; i <= n; i++) {
         cin >> x >> d[i];
         if (x) add(x, i);
         else r = i;
         sum += d[i];
     }
    dfs(r);
    if (ans.size() > 2) {
        for (int i =0; i < 2; i++) cout << ans[i] << " ";
    }else puts("-1");
    return 0;
}

5843. 染色

由图可知,所有不连贯的色区边界一定是两色切换的边。

所以,只要遍历整颗树,选两色色块的较小值作为答案。

输入样例1:
复制代码
11
0 0 0 1 1 0 1 0 0 1 1
1 2
1 3
2 4
2 5
5 6
5 7
3 8
3 9
3 10
9 11
输出样例1:
复制代码
2

要注意根节点由于没有父节点,所以和根节点连接的块应该额外加上。

输入

复制代码
15
0 1 0 0 1 1 0 1 1 1 1 1 0 1 0
10 7
10 3
10 8
5 7
13 14
8 13
15 4
15 13
5 2
9 3
11 15
13 6
1 12
9 1

标准答案

复制代码
3
相关推荐
爱读书的小胖8 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌8 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F9 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_307779139 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
tomwang03229 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!9 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
2501_9269783310 小时前
人机通信协议--人和机器之间的交互想象
人工智能·经验分享·算法·ai写作
行者全栈架构师10 小时前
【鸿蒙心迹】互动卡片全链路——把核心功能放到桌面(FormKit 实战)(HarmonyOS 7.x)
前端·算法·架构
无定义_10 小时前
10.11日常训练
算法
Code_Solitude10 小时前
c语言:关于qsoet函数知识点
c语言·数据结构·算法